# frozen_string_literal: true

require 'logger'

module RubyLanguageServer
  level_name = ENV.fetch('LOG_LEVEL', 'error').upcase || 'DEBUG'
  level = Logger::Severity.const_get(level_name)
  class << self
    attr_accessor :logger
  end
  @logger = ::Logger.new($stderr, level:)
  @logger.log(level, "Logger started at level #{level_name} -> #{level}")
end
